/* 
-*- coding: latin-1 -*-

This file is part of RefactorErl.

RefactorErl is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

RefactorErl is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with RefactorErl.  If not, see <http://plc.inf.elte.hu/erlang/>.

The Original Code is RefactorErl.

The Initial Developer of the Original Code is Eötvös Loránd University.
Portions created  by Eötvös Loránd University and ELTE-Soft Ltd.
are Copyright 2007-2013 Eötvös Loránd University, ELTE-Soft Ltd.
and Ericsson Hungary. All Rights Reserved.
*/

package com.refactorerl.ui.logic.filelist;

import java.util.logging.Logger;

import com.ericsson.otp.erlang.OtpErlangAtom;
import com.ericsson.otp.erlang.OtpErlangObject;
import com.ericsson.otp.erlang.OtpErlangString;
import com.ericsson.otp.erlang.OtpErlangTuple;
import com.refactorerl.ui.communication.ReferlProxy;
import com.refactorerl.ui.logic.AbstractRequest;

public class AddEnvRequest extends AbstractRequest<Object> {

	static public enum Environment {
		APP_BASE, INCLUDE
	};

	
	private OtpErlangTuple request;

	public AddEnvRequest(Environment envName, String value, ReferlProxy proxy,
			Logger logger) {
		super(proxy, logger);
		String envNameStr;
		switch (envName) {
		case APP_BASE:
			envNameStr = "appbase"; //$NON-NLS-1$
			break;
		case INCLUDE:
			envNameStr = "include"; //$NON-NLS-1$
			break;
		default:
			throw new IllegalArgumentException("envName must not be null"); //$NON-NLS-1$
		}
		
		request = new OtpErlangTuple(new OtpErlangObject[] {
				new OtpErlangAtom("add_env"), new OtpErlangAtom(envNameStr), //$NON-NLS-1$
				new OtpErlangString(value) });
	}

	@Override
	public boolean isModifier() {
		return true;
	}
	
	@Override
	protected OtpErlangObject doGetRequest() {
		return request;
	}

	@Override
	protected Object doProcessReply(OtpErlangObject m) {

		return null;
	}

}
