/* 
-*- coding: latin-1 -*-

This file is part of RefactorErl.

RefactorErl is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

RefactorErl is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with RefactorErl.  If not, see <http://plc.inf.elte.hu/erlang/>.

The Original Code is RefactorErl.

The Initial Developer of the Original Code is Eötvös Loránd University.
Portions created  by Eötvös Loránd University and ELTE-Soft Ltd.
are Copyright 2007-2013 Eötvös Loránd University, ELTE-Soft Ltd.
and Ericsson Hungary. All Rights Reserved.
*/

package com.refactorerl.ui.presentation;

import org.eclipse.core.expressions.PropertyTester;
import org.eclipse.ui.IPerspectiveDescriptor;

/**
 * The test method in this class returns true iff the currently active perspective is a RefactorErl or an Erlide perspective.
 * 
 * @author Daniel Lukacs, 2014 ELTE IK
 *
 */
public class PerspectivePropertyTester extends PropertyTester {

	@Override
	public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {
		IPerspectiveDescriptor perspective = Activator.getDefault().getWorkbench().getActiveWorkbenchWindow()
				.getActivePage().getPerspective();
		String perspectiveId = perspective.getId();

		if (perspectiveId.equals("com.refactorerl.ui.refactorerlPerspective") || perspectiveId.equals("org.erlide.ui.perspectives.ErlangPerspective")) { //$NON-NLS-1$ //$NON-NLS-2$
			return true;
		}
		return false;

	}

}
